// Code generated by goa v3.12.3, DO NOT EDIT.
//
// login client HTTP transport
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/login/design

package client

import (
	"context"
	"net/http"

	goahttp "goa.design/goa/v3/http"
	goa "goa.design/goa/v3/pkg"
)

// Client lists the login service endpoint HTTP clients.
type Client struct {
	// Login Doer is the HTTP client used to make requests to the Login endpoint.
	LoginDoer goahttp.Doer

	// LoginInvitation Doer is the HTTP client used to make requests to the
	// LoginInvitation endpoint.
	LoginInvitationDoer goahttp.Doer

	// LoginWithVC Doer is the HTTP client used to make requests to the LoginWithVC
	// endpoint.
	LoginWithVCDoer goahttp.Doer

	// Keys Doer is the HTTP client used to make requests to the Keys endpoint.
	KeysDoer goahttp.Doer

	// RestoreResponseBody controls whether the response bodies are reset after
	// decoding so they can be read again.
	RestoreResponseBody bool

	scheme  string
	host    string
	encoder func(*http.Request) goahttp.Encoder
	decoder func(*http.Response) goahttp.Decoder
}

// NewClient instantiates HTTP clients for all the login service servers.
func NewClient(
	scheme string,
	host string,
	doer goahttp.Doer,
	enc func(*http.Request) goahttp.Encoder,
	dec func(*http.Response) goahttp.Decoder,
	restoreBody bool,
) *Client {
	return &Client{
		LoginDoer:           doer,
		LoginInvitationDoer: doer,
		LoginWithVCDoer:     doer,
		KeysDoer:            doer,
		RestoreResponseBody: restoreBody,
		scheme:              scheme,
		host:                host,
		decoder:             dec,
		encoder:             enc,
	}
}

// Login returns an endpoint that makes HTTP requests to the login service
// Login server.
func (c *Client) Login() goa.Endpoint {
	var (
		encodeRequest  = EncodeLoginRequest(c.encoder)
		decodeResponse = DecodeLoginResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildLoginRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		err = encodeRequest(req, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.LoginDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("login", "Login", err)
		}
		return decodeResponse(resp)
	}
}

// LoginInvitation returns an endpoint that makes HTTP requests to the login
// service LoginInvitation server.
func (c *Client) LoginInvitation() goa.Endpoint {
	var (
		decodeResponse = DecodeLoginInvitationResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildLoginInvitationRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.LoginInvitationDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("login", "LoginInvitation", err)
		}
		return decodeResponse(resp)
	}
}

// LoginWithVC returns an endpoint that makes HTTP requests to the login
// service LoginWithVC server.
func (c *Client) LoginWithVC() goa.Endpoint {
	var (
		encodeRequest  = EncodeLoginWithVCRequest(c.encoder)
		decodeResponse = DecodeLoginWithVCResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildLoginWithVCRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		err = encodeRequest(req, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.LoginWithVCDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("login", "LoginWithVC", err)
		}
		return decodeResponse(resp)
	}
}

// Keys returns an endpoint that makes HTTP requests to the login service Keys
// server.
func (c *Client) Keys() goa.Endpoint {
	var (
		decodeResponse = DecodeKeysResponse(c.decoder, c.RestoreResponseBody)
	)
	return func(ctx context.Context, v any) (any, error) {
		req, err := c.BuildKeysRequest(ctx, v)
		if err != nil {
			return nil, err
		}
		resp, err := c.KeysDoer.Do(req)
		if err != nil {
			return nil, goahttp.ErrRequestError("login", "Keys", err)
		}
		return decodeResponse(resp)
	}
}
